/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.GaussianFilter;

import javax.swing.JPanel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.gui.widgets.RunButton;
import org.visnow.vn.gui.widgets.SectionHeader;
import static org.visnow.vn.lib.basic.filters.GaussianFilter.GaussianFilterShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends JPanel
{

    private Parameters parameters;

    /**
     * Creates new form InterpolateFieldUI
     */
    public GUI()
    {
        initComponents();
        updateSectionPanelVisualState();
    }

    public void updateSectionPanelVisualState()
    {
        bandPassPanel.setVisible(bandPassHeader.isExpanded());
        bandPassPanel.setEnabled(bandPassHeader.isSelected());
        sigma1Slider.setEnabled(bandPassHeader.isSelected());
        sigma1Label.setEnabled(bandPassHeader.isSelected());
        absBandBox.setEnabled(bandPassHeader.isSelected());
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(final ParameterProxy p, boolean resetFully, boolean setRunButtonPending)
    {
        sigmaSlider.setValue(p.get(SIGMA));
        sigma1Slider.setValue(p.get(SIGMA1));
        highPassBox.setSelected(p.get(HIGH_PASS));
        absHighBox.setSelected(p.get(HIGH_ABS));
        bandPassHeader.setSelected(p.get(BAND_PASS));
        absBandBox.setSelected(p.get(BAND_ABS));

        updateSectionPanelVisualState();

        runButton.updateAutoState(p.get(RUNNING_MESSAGE));
        runButton.updatePendingState(setRunButtonPending);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        sigmaSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        jPanel1 = new javax.swing.JPanel();
        highPassBox = new javax.swing.JCheckBox();
        absHighBox = new javax.swing.JCheckBox();
        bandPassHeader = new org.visnow.vn.gui.widgets.SectionHeader();
        bandPassPanel = new javax.swing.JPanel();
        absBandBox = new javax.swing.JCheckBox();
        sigma1Label = new javax.swing.JLabel();
        sigma1Slider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        runButton = new org.visnow.vn.gui.widgets.RunButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setBorder(javax.swing.BorderFactory.createEmptyBorder(4, 4, 4, 4));
        setLayout(new java.awt.GridBagLayout());

        jLabel3.setText("Low pass filter (smooth):");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabel3, gridBagConstraints);

        jLabel1.setText("Sigma:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 0, 0);
        add(jLabel1, gridBagConstraints);

        sigmaSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        sigmaSlider.setGlobalMin(1e-6);
        sigmaSlider.setMax(30);
        sigmaSlider.setMin(0.1);
        sigmaSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        sigmaSlider.setSubmitOnAdjusting(false);
        sigmaSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                sigmaSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 0);
        add(sigmaSlider, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        highPassBox.setText("Compute high pass");
        highPassBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        highPassBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                highPassBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        jPanel1.add(highPassBox, gridBagConstraints);

        absHighBox.setText("Absolute value");
        absHighBox.setEnabled(false);
        absHighBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        absHighBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                absHighBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(absHighBox, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 0);
        add(jPanel1, gridBagConstraints);

        bandPassHeader.setExpanded(false);
        bandPassHeader.setShowSeparator(false);
        bandPassHeader.setText("Band pass");
        bandPassHeader.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                bandPassHeaderUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(8, 0, 0, 0);
        add(bandPassHeader, gridBagConstraints);

        bandPassPanel.setEnabled(false);
        bandPassPanel.setLayout(new java.awt.GridBagLayout());

        absBandBox.setText("Absolute value");
        absBandBox.setEnabled(false);
        absBandBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        absBandBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                absBandBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        bandPassPanel.add(absBandBox, gridBagConstraints);

        sigma1Label.setText("Sigma:");
        sigma1Label.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        bandPassPanel.add(sigma1Label, gridBagConstraints);

        sigma1Slider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        sigma1Slider.setGlobalMin(1e-6);
        sigma1Slider.setMax(30);
        sigma1Slider.setMin(0.1);
        sigma1Slider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        sigma1Slider.setSubmitOnAdjusting(false);
        sigma1Slider.setEnabled(false);
        sigma1Slider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                sigma1SliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        bandPassPanel.add(sigma1Slider, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 0, 0);
        add(bandPassPanel, gridBagConstraints);

        runButton.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                runButtonUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(8, 0, 0, 0);
        add(runButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void runButtonUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButtonUserChangeAction
    {//GEN-HEADEREND:event_runButtonUserChangeAction
        parameters.set(RUNNING_MESSAGE, (RunButton.RunState) evt.getEventData());
    }//GEN-LAST:event_runButtonUserChangeAction

    private void highPassBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_highPassBoxActionPerformed
    {//GEN-HEADEREND:event_highPassBoxActionPerformed
        parameters.set(HIGH_PASS, highPassBox.isSelected());
        absHighBox.setEnabled(highPassBox.isSelected());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_highPassBoxActionPerformed

    private void absHighBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_absHighBoxActionPerformed
    {//GEN-HEADEREND:event_absHighBoxActionPerformed
        parameters.set(HIGH_ABS, absHighBox.isSelected());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_absHighBoxActionPerformed

    private void sigmaSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_sigmaSliderUserChangeAction
    {//GEN-HEADEREND:event_sigmaSliderUserChangeAction
        parameters.set(SIGMA, (Float) sigmaSlider.getValue());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_sigmaSliderUserChangeAction

    private void sigma1SliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_sigma1SliderUserChangeAction
    {//GEN-HEADEREND:event_sigma1SliderUserChangeAction
        parameters.set(SIGMA1, (Float) sigma1Slider.getValue());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_sigma1SliderUserChangeAction

    private void bandPassHeaderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_bandPassHeaderUserChangeAction
    {//GEN-HEADEREND:event_bandPassHeaderUserChangeAction
        updateSectionPanelVisualState();
        if (evt.getEventType() == SectionHeader.EVENT_CHECKBOX_SWITCHED) {
            parameters.set(BAND_PASS, bandPassHeader.isSelected());
            runButton.setPendingIfNoAuto();
        }
    }//GEN-LAST:event_bandPassHeaderUserChangeAction

    private void absBandBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_absBandBoxActionPerformed
    {//GEN-HEADEREND:event_absBandBoxActionPerformed
        parameters.set(BAND_ABS, absBandBox.isSelected());
        runButton.setPendingIfNoAuto();
    }//GEN-LAST:event_absBandBoxActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox absBandBox;
    private javax.swing.JCheckBox absHighBox;
    private org.visnow.vn.gui.widgets.SectionHeader bandPassHeader;
    private javax.swing.JPanel bandPassPanel;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JCheckBox highPassBox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.gui.widgets.RunButton runButton;
    private javax.swing.JLabel sigma1Label;
    private org.visnow.vn.gui.widgets.ExtendedSlider sigma1Slider;
    private org.visnow.vn.gui.widgets.ExtendedSlider sigmaSlider;
    // End of variables declaration//GEN-END:variables

}
